package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.WXOrgSector;
import com.sa.ibiz.demo.demo.service.WXOrgSectorService;
import com.sa.ibiz.demo.demo.service.dto.WXOrgSectorSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/wxorgsector")
public class WXOrgSectorResource
{
	@Autowired
	private WXOrgSectorService service;


	@PostMapping(value = "/checkKey")
	public ResponseEntity<WXOrgSector> checkKey(@Validated @RequestBody WXOrgSector data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("微信部门[checkKey]操作发生错误","WXOrgSector",data.getWxorgsectorid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<WXOrgSector> update(@Validated @RequestBody WXOrgSector data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("微信部门[update]操作发生错误","WXOrgSector",data.getWxorgsectorid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<WXOrgSector> create(@Validated @RequestBody WXOrgSector data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("微信部门[create]操作发生错误","WXOrgSector",data.getWxorgsectorid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<WXOrgSector> getDraft(@Validated @RequestBody WXOrgSector data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("微信部门[getDraft]操作发生错误","WXOrgSector","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<WXOrgSector> remove(@Validated @RequestBody WXOrgSector data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("微信部门[remove]操作发生错误","WXOrgSector",data.getWxorgsectorid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<WXOrgSector> get(@Validated @PathVariable String id){
		WXOrgSector data=new WXOrgSector();
		data.setWxorgsectorid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("微信部门[get]操作发生错误","WXOrgSector",id.toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<WXOrgSector>> searchDefaultPage(@Validated @RequestBody WXOrgSectorSearchFilter filter){
		Page<WXOrgSector> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<WXOrgSector>> listDefault(@Validated @RequestBody WXOrgSectorSearchFilter filter){
		List<WXOrgSector> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
